/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#ifndef V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_TYPES_SOMEIP_STUB_ADAPTER_HPP_
#define V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_TYPES_SOMEIP_STUB_ADAPTER_HPP_

#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesStub.hpp>
#include <v1/commonapi/telux/common/CommonDefinesSomeIPStubAdapter.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesSomeIPDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/AddressTranslator.hpp>
#include <CommonAPI/SomeIP/StubAdapterHelper.hpp>
#include <CommonAPI/SomeIP/StubAdapter.hpp>
#include <CommonAPI/SomeIP/Factory.hpp>
#include <CommonAPI/SomeIP/Types.hpp>
#include <CommonAPI/SomeIP/Constants.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

template <typename _Stub = ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStub, typename... _Stubs>
class Cv2xRadioTypesSomeIPStubAdapterInternal
    : public virtual Cv2xRadioTypesStubAdapter,
      public ::v1::commonapi::telux::common::CommonDefinesSomeIPStubAdapterInternal<_Stub, _Stubs...>
{
public:
    typedef CommonAPI::SomeIP::StubAdapterHelper< _Stub, _Stubs...> Cv2xRadioTypesSomeIPStubAdapterHelper;

    ~Cv2xRadioTypesSomeIPStubAdapterInternal() {
        deactivateManagedInstances();
        Cv2xRadioTypesSomeIPStubAdapterHelper::deinit();
    }

    void deactivateManagedInstances() {}
    
    virtual void init(std::shared_ptr<CommonAPI::SomeIP::StubAdapter> instance) {
        return Cv2xRadioTypesSomeIPStubAdapterHelper::init(instance);
    }

    virtual void deinit() {
        return Cv2xRadioTypesSomeIPStubAdapterHelper::deinit();
    }

    virtual bool onInterfaceMessage(const CommonAPI::SomeIP::Message &_message) {
        return Cv2xRadioTypesSomeIPStubAdapterHelper::onInterfaceMessage(_message);
    }
    
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStub,
        CommonAPI::Version
    > getCv2xRadioTypesInterfaceVersionStubDispatcher;

    Cv2xRadioTypesSomeIPStubAdapterInternal(
        const CommonAPI::SomeIP::Address &_address,
        const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub):
        CommonAPI::SomeIP::StubAdapter(_address, _connection),
                ::v1::commonapi::telux::common::CommonDefinesSomeIPStubAdapterInternal<_Stub, _Stubs...>(_address, _connection, _stub),
        getCv2xRadioTypesInterfaceVersionStubDispatcher(&Cv2xRadioTypesStub::lockInterfaceVersionAttribute, &Cv2xRadioTypesStub::getInterfaceVersion, false, true)
    {
        // Provided events/fields
    }

    // Register/Unregister event handlers for selective broadcasts
    void registerSelectiveEventHandlers();
    void unregisterSelectiveEventHandlers();

};


template <typename _Stub, typename... _Stubs>
void Cv2xRadioTypesSomeIPStubAdapterInternal<_Stub, _Stubs...>::registerSelectiveEventHandlers() {
}

template <typename _Stub, typename... _Stubs>
void Cv2xRadioTypesSomeIPStubAdapterInternal<_Stub, _Stubs...>::unregisterSelectiveEventHandlers() {
}

template <typename _Stub = ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStub, typename... _Stubs>
class Cv2xRadioTypesSomeIPStubAdapter
    : public Cv2xRadioTypesSomeIPStubAdapterInternal<_Stub, _Stubs...> {
public:
    Cv2xRadioTypesSomeIPStubAdapter(const CommonAPI::SomeIP::Address &_address,
                                            const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
                                            const std::shared_ptr<CommonAPI::StubBase> &_stub)
        : CommonAPI::SomeIP::StubAdapter(_address, _connection),
          Cv2xRadioTypesSomeIPStubAdapterInternal<_Stub, _Stubs...>(_address, _connection, _stub) {
    }
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Types_SOMEIP_STUB_ADAPTER_HPP_
